from .korean import join_jamos
import re
import pyopenjtalk

patt_repl = [
    ('ア|ァ',    'a'),
    ('イ|ィ',    'i'),
    ('ウ|ゥ',    'u'),
    ('エ|ェ',    'e'),
    ('オ|ォ',    'o'),
    ('カ',       'ka'),
    ('キ',       'ki'),
    ('ク',       'ku'),
    ('ケ',       'ke'),
    ('コ',       'ko'),
    ('ガ',       'ga'),
    ('ギ',       'gi'),
    ('グ',       'gu'),
    ('ゲ',       'ge'),
    ('ゴ',       'go'),
    ('サ',       'sa'),
    ('シ',       'si'),
    ('ス',       'ㅅㅡ'),
    ('セ',       'se'),
    ('ソ',       'so'),
    ('ザ',       'za'),
    ('ジ',       'zi'),
    ('ズ',       'ㅈㅡ'),
    ('ゼ',       'ze'),
    ('ゾ',       'zo'),
    ('タ',       'ta'),
    ('チ',       'ci'),
    ('ツ',       'cu'),
    ('テ',       'te'),
    ('ト',       'to'),
    ('ダ',       'da'),
    ('ヂ',       'zi'),
    ('ヅ',       'zu'),
    ('デ',       'de'),
    ('ド',       'do'),
    ('ナ',       'na'),
    ('ニ',       'ni'),
    ('ヌ',       'nu'),
    ('ネ',       'ne'),
    ('ノ',       'no'),
    ('ハ',       'ha'),
    ('ヒ',       'hi'),
    ('フ',       'hu'),
    ('ヘ',       'he'),
    ('ホ',       'ho'),
    ('バ',       'ba'),
    ('ビ',       'bi'),
    ('ブ',       'bu'),
    ('ベ',       'be'),
    ('ボ',       'bo'),
    ('パ',       'pa'),
    ('ピ',       'pi'),
    ('プ',       'pu'),
    ('ペ',       'pe'),
    ('ポ',       'po'),
    ('マ',       'ma'),
    ('ミ',       'mi'),
    ('ム',       'mu'),
    ('メ',       'me'),
    ('モ',       'mo'),
    ('ヤ',       'ya'),
    ('ユ',       'yu'),
    ('ヨ',       'yo'),
    ('ャ',       'ja'),
    ('ュ',       'ju'),
    ('ョ',       'jo'),
    ('ラ',       'la'),
    ('リ',       'li'),
    ('ル',       'lu'),
    ('レ',       'le'),
    ('ロ',       'lo'),
    ('ワ',       'wa'),
    ('ヲ',       'o'),
    ('ン',       'N'),
    ('ッ',       'T'),
    ('ー',       ''),

    (r'T([gsd])', r'\1\1'),
    (r'T([c])', r'ㄷ\1'),
    (r'T([p])', r'ㅂ\1'),
    (r'N([mbp])', r'ㅁ\1'),
    (r'N([sztcdnl])', r'ㄴ\1'),
    (r'N([kghaiueoy])', r'ㅇ\1'),
    
    ('wa',        'ㅘ'),
    ('k',         'ㅋ'),
    ('g',         'ㄱ'),
    ('s',         'ㅅ'),
    ('z',         'ㅈ'),
    ('t',         'ㅌ'),
    ('c',         'ㅊ'),
    ('d',         'ㄷ'),
    ('n',         'ㄴ'),
    ('h',         'ㅎ'),
    ('b',         'ㅂ'),
    ('p',         'ㅍ'),
    ('m',         'ㅁ'),
    ('l',         'ㄹ'),
    ('ya',        'ㅑ'),
    ('yu',        'ㅠ'),
    ('yo',        'ㅛ'),
    ('ija',       'ㅑ'),
    ('iju',       'ㅠ'),
    ('ijo',       'ㅛ'),
    ('a',         'ㅏ'),
    ('i',         'ㅣ'),
    ('u',         'ㅜ'),
    ('e',         'ㅔ'),
    ('o',         'ㅗ'),
    ('・',       ' '),
]

def convert_jpn(string):
    jpn_words = set(re.findall("[ぁ-んァ-ン一-龯']+", string))
    for jpn_word in jpn_words:
        word = pyopenjtalk.g2p(jpn_word, kana=True)
        for pattern, repl in patt_repl:
            word = re.sub(pattern, repl, word)
        word = join_jamos(re.sub(r'([ㅏ-ㅣ]+)', r'ㅇ\1', join_jamos(word)))\
            .replace('N', 'ㅇㅡㅇ').replace('ㅇㅇ', 'ㅇ') \
            .replace('T', 'ㅇㅡㅅ')
        word = join_jamos(word)

        string = string.replace(jpn_word, word)
    return string